/*
  Implementation of associative arrays (indexed by string) that store
  integer values.

  Diego Zamboni, Mar 7, 1997.

  */

#ifndef __ASSOC_ARRAY_INT_H_
#define __ASSOC_ARRAY_INT_H_

/* #define HASHSIZE 503 */
/* #define HASHSIZE 8003 */
/* larger hash table => faster code & slightly higher memory consumption */
#define HASHSIZE 16007

typedef struct assoc_array_int_node_struct {
    char *index;
    int value;
    struct assoc_array_int_node_struct *next;
} *assoc_array_int_node;

typedef struct assoc_array_int_node_struct *assoc_array_int[HASHSIZE];

void assoc_array_int_init(assoc_array_int as);
void assoc_array_int_set(assoc_array_int as, char *ind, int val);
int assoc_array_int_get(assoc_array_int as, char *ind);
void assoc_array_int_add(assoc_array_int as, char *ind, int val);
assoc_array_int_node assoc_array_int_lookup(assoc_array_int as, char *ind);
void assoc_array_int_del_node(struct assoc_array_int_node_struct * node);

#endif
